﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Reactive.Linq;
using System.Text;
using System.Threading.Tasks;
using VL.Lib.Collections;
using VL.Core;

namespace EnumCustom
{
    public class BW_EnumVideoStyle
    {
        public string Update(VideoStyle enumInput)
        {
            if (enumInput.IsValid())
                return enumInput.Definition.Entries[enumInput.SelectedIndex()];
            else
                return "bw_filenotfound";
        }

        public VideoStyleDefinition GetDefinition()
        {
            return VideoStyleDefinition.Instance;
        }

        public void AddEnumEntry(string entry)
        {
            if(!VideoStyleDefinition.Instance.ContainsEntry(entry))
            {
                VideoStyleDefinition.Instance.AddEntry(entry, null);
            }

        }

        public void RemoveEnumEntry(string entry)
        {
            VideoStyleDefinition.Instance.RemoveEntry(entry);
        }
    }

    public class VideoStyleDefinition : ManualDynamicEnumDefinitionBase<VideoStyleDefinition>
    {
        //this is optional an can be used if any initialization before the call to GetEntries is needed
        protected override void Initialize()
        {
            AddEntry("bw_filenotfound", null);//add two default entries on initialization
        }

        //add this to get a node that can access the Instance from everywhere
        public static VideoStyleDefinition Instance => ManualDynamicEnumDefinitionBase<VideoStyleDefinition>.Instance;
    }


    [Serializable]
    public class VideoStyle : DynamicEnumBase<VideoStyle, VideoStyleDefinition>
    {
        public VideoStyle(string value) : base(value)
        {
        }

        //this method needs to be imported in VL to set the default
        public static VideoStyle CreateDefault()
        {
            //use method of base class if nothing special required
            return CreateDefaultBase();
        }
    }
    public class BW_EnumTextureStyle
    {
        public string Update(TextureStyle enumInput)
        {
            if (enumInput.IsValid())
                return enumInput.Definition.Entries[enumInput.SelectedIndex()];
            else
                return "bw_filenotfound";
        }

        public TextureStyleDefinition GetDefinition()
        {
            return TextureStyleDefinition.Instance;
        }

        public void AddEnumEntry(string entry)
        {
            if (!TextureStyleDefinition.Instance.ContainsEntry(entry))
            {
                TextureStyleDefinition.Instance.AddEntry(entry, null);
            }
            
        }

        public void RemoveEnumEntry(string entry)
        {
            TextureStyleDefinition.Instance.RemoveEntry(entry);
        }
    }

    public class TextureStyleDefinition : ManualDynamicEnumDefinitionBase<TextureStyleDefinition>
    {
        //this is optional an can be used if any initialization before the call to GetEntries is needed
        protected override void Initialize()
        {
            AddEntry("bw_filenotfound", null);//add two default entries on initialization
        }

        //add this to get a node that can access the Instance from everywhere
        public static TextureStyleDefinition Instance => ManualDynamicEnumDefinitionBase<TextureStyleDefinition>.Instance;
    }


    [Serializable]
    public class TextureStyle : DynamicEnumBase<TextureStyle, TextureStyleDefinition>
    {
        public TextureStyle(string value) : base(value)
        {
        }

        //this method needs to be imported in VL to set the default
        public static TextureStyle CreateDefault()
        {
            //use method of base class if nothing special required
            return CreateDefaultBase();
        }
    }


    public class BW_EnumTextStyle
    {
        public string Update(TextStyle enumInput)
        {
            if (enumInput.IsValid())
                return enumInput.Definition.Entries[enumInput.SelectedIndex()];
            else
                return "bw_filenotfound";
        }

        public TextStyleDefinition GetDefinition()
        {
            return TextStyleDefinition.Instance;
        }

        public void AddEnumEntry(string entry)
        {
            if (!TextStyleDefinition.Instance.ContainsEntry(entry))
            {
                TextStyleDefinition.Instance.AddEntry(entry, null);
            }
            
        }

        public void RemoveEnumEntry(string entry)
        {
            TextStyleDefinition.Instance.RemoveEntry(entry);
        }
    }

    public class TextStyleDefinition : ManualDynamicEnumDefinitionBase<TextStyleDefinition>
    {
        //this is optional an can be used if any initialization before the call to GetEntries is needed
        protected override void Initialize()
        {
            AddEntry("bw_filenotfound", null);//add two default entries on initialization
        }

        //add this to get a node that can access the Instance from everywhere
        public static TextStyleDefinition Instance => ManualDynamicEnumDefinitionBase<TextStyleDefinition>.Instance;
    }


    [Serializable]
    public class TextStyle : DynamicEnumBase<TextStyle, TextStyleDefinition>
    {
        public TextStyle(string value) : base(value)
        {
        }

        //this method needs to be imported in VL to set the default
        public static TextStyle CreateDefault()
        {
            //use method of base class if nothing special required
            return CreateDefaultBase();
        }
    }

    public class BW_EnumButtonStyle
    {
        public string Update(ButtonStyle enumInput)
        {
            if (enumInput.IsValid())
                return enumInput.Definition.Entries[enumInput.SelectedIndex()];
            else
                return "bw_filenotfound";
        }

        public ButtonStyleDefinition GetDefinition()
        {
            return ButtonStyleDefinition.Instance;
        }

        public void AddEnumEntry(string entry)
        {
            if (!ButtonStyleDefinition.Instance.ContainsEntry(entry))
            {
                ButtonStyleDefinition.Instance.AddEntry(entry, null);
            }
            
        }

        public void RemoveEnumEntry(string entry)
        {
            ButtonStyleDefinition.Instance.RemoveEntry(entry);
        }
    }


    public class ButtonStyleDefinition : ManualDynamicEnumDefinitionBase<ButtonStyleDefinition>
    {
        //this is optional an can be used if any initialization before the call to GetEntries is needed
        protected override void Initialize()
        {
            AddEntry("bw_filenotfound", null);//add two default entries on initialization
        }

        //add this to get a node that can access the Instance from everywhere
        public static ButtonStyleDefinition Instance => ManualDynamicEnumDefinitionBase<ButtonStyleDefinition>.Instance;
    }


    [Serializable]
    public class ButtonStyle : DynamicEnumBase<ButtonStyle, ButtonStyleDefinition>
    {
        public ButtonStyle(string value) : base(value)
        {
        }

        //this method needs to be imported in VL to set the default
        public static ButtonStyle CreateDefault()
        {
            //use method of base class if nothing special required
            return CreateDefaultBase();
        }
    }



}
